using Test

function verificaSort()
  @test ordena([]) == []
  @test ordena([1, 2, 3]) == [1, 2, 3]
  @test ordena([1, 1, 1]) == [1, 1, 1]
  @test ordena([3, 2, 1]) == [1, 2, 3]
  @test ordena([3, -12, 1]) == [-12, 1, 3]
  @test ordena([3, 5, 2, 76, 23, 1, 8, 7, 3, 1, 12]) == [1, 1, 2, 3, 3, 5, 7, 8, 12, 23, 76]
  println("Final dos testes")
end

function ordena(v)
   return quickSort(1, length(v), v)
end

function troca(v, i, j)
   aux = v[i]
   v[i] = v[j]
   v[j] = aux
end

# ideia
# encontrar um pivo
# separo o vetor entre <= pivo e >pivo
# faço a ordenação das duas parte
function quickSort(i, j, v)
   if j > i
     pivo = v[1] # v[div(i + j, 2)]
     left = i
     right = j
     while left <= right
        while v[left] < pivo
          left = left + 1
        end
        while v[right] > pivo 
          right = right - 1
        end
        if left <= right
           troca(v, left, right)
           left = left + 1
           right = right - 1
        end
     end
     quickSort(i, right, v)
     quickSort(left, j, v)
   end
   return v
end


verificaSort()

