include("merge.jl")
using Test

function verificaSort()
  @test ordena([]) == []
  @test ordena([1, 2, 3]) == [1, 2, 3]
  @test ordena([1, 1, 1]) == [1, 1, 1]
  @test ordena([3, 2, 1]) == [1, 2, 3]
  @test ordena([3, -12, 1]) == [-12, 1, 3]
  @test ordena([3, 5, 2, 76, 23, 1, 8, 7, 3, 1, 12]) == [1, 1, 2, 3, 3, 5, 7, 8, 12, 23, 76]
  println("Final dos testes")
end

function ordena(v)
   return mergeSort(v)
end
# ideia
# Divida o vetor no meio
# Ordene cada parte separadamente
# devolva o merge
function mergeSort(v)
   if length(v) <= 1
     return v
   end
   meio = div(length(v), 2)
   v1 = v[1:meio]
   v2 = v[meio + 1:length(v)]
   v1ord = mergeSort(v1)
   v2ord = mergeSort(v2)
   return merge(v1ord, v2ord)
end


verificaSort()
